searchData={"items":[{"type":"module","title":"EView","doc":"This plug will take `body_params` from Plug.Conn structure\nand re-render it with appropriate structure to `resp_body`.\n\nWhat is appropriate structure? Take look at [Nebo #15 API Manifest](http://docs.apimanifest.apiary.io/#).\n\n# Example:\nAdd to your `endpoint.ex` before Plug.Parsers plug:\n\n      plug EView\n      plug EView.Plugs.Idempotency","ref":"EView.html"},{"type":"function","title":"EView.call/2","doc":"","ref":"EView.html#call/2"},{"type":"function","title":"EView.init/1","doc":"","ref":"EView.html#init/1"},{"type":"function","title":"EView.put_response/2","doc":"","ref":"EView.html#put_response/2"},{"type":"function","title":"EView.wrap_body/2","doc":"Update `body` and add all meta objects that is required by API Manifest structure.","ref":"EView.html#wrap_body/2"},{"type":"module","title":"EView.AcceptanceCase","doc":"This module defines the test case to be used by\nacceptance tests. It can allow run tests in async when each SQL.Sandbox connection will be\nbinded to a specific test.","ref":"EView.AcceptanceCase.html"},{"type":"function","title":"EView.AcceptanceCase.get_body/1","doc":"","ref":"EView.AcceptanceCase.html#get_body/1"},{"type":"module","title":"EView.Changeset.Validators.Email","doc":"This helper validates emails by complex regex pattern.","ref":"EView.Changeset.Validators.Email.html"},{"type":"function","title":"EView.Changeset.Validators.Email.validate_email/3","doc":"","ref":"EView.Changeset.Validators.Email.html#validate_email/3"},{"type":"module","title":"EView.Changeset.Validators.Metadata","doc":"This helper validates metadata corresponding to\n[API Manifest](http://docs.apimanifest.apiary.io/#introduction/optional-features/metadata).","ref":"EView.Changeset.Validators.Metadata.html"},{"type":"function","title":"EView.Changeset.Validators.Metadata.validate_metadata/3","doc":"","ref":"EView.Changeset.Validators.Metadata.html#validate_metadata/3"},{"type":"module","title":"EView.Changeset.Validators.PhoneNumber","doc":"This helper validates phone numbers in international format (with `+:country_code`).","ref":"EView.Changeset.Validators.PhoneNumber.html"},{"type":"function","title":"EView.Changeset.Validators.PhoneNumber.validate_phone_number/3","doc":"","ref":"EView.Changeset.Validators.PhoneNumber.html#validate_phone_number/3"},{"type":"module","title":"EView.Plugs.Idempotency","doc":"This Plug allows to take `X-Idempotency-Key` header from request and sent it back to client.","ref":"EView.Plugs.Idempotency.html"},{"type":"module","title":"Examples - EView.Plugs.Idempotency","doc":"Modify your `endpoint.ex` and add before `plug MyApp.Router`:\n\n    plug EView.Plugs.Idempotency","ref":"EView.Plugs.Idempotency.html#module-examples"},{"type":"function","title":"EView.Plugs.Idempotency.call/2","doc":"","ref":"EView.Plugs.Idempotency.html#call/2"},{"type":"function","title":"EView.Plugs.Idempotency.init/1","doc":"","ref":"EView.Plugs.Idempotency.html#init/1"},{"type":"module","title":"EView.Renders.Error","doc":"This module renders `error` property from response structure.","ref":"EView.Renders.Error.html"},{"type":"function","title":"EView.Renders.Error.render/1","doc":"Renders error view.","ref":"EView.Renders.Error.html#render/1"},{"type":"module","title":"EView.Renders.Meta","doc":"This module renders `meta` property from response structure.","ref":"EView.Renders.Meta.html"},{"type":"function","title":"EView.Renders.Meta.render/2","doc":"Renders `meta` view by data_type (may be `object` or `list`) and connection `conn`.","ref":"EView.Renders.Meta.html#render/2"},{"type":"module","title":"EView.Renders.Root","doc":"This module converts map to a structure that corresponds\nto [Nebo #15 API Manifest](http://docs.apimanifest.apiary.io/) response structure.","ref":"EView.Renders.Root.html"},{"type":"function","title":"EView.Renders.Root.render/2","doc":"Render response object or error description following to our guidelines.\n\nThis method will look into status code and:\n  * create `error` property from response data when HTTP status code is `4XX` or `5XX`;\n  * create `data` property for other HTTP status codes.","ref":"EView.Renders.Root.html#render/2"},{"type":"module","title":"EView.Views.Error","doc":"Views for different kind of 4xx and 5xx error of your application.","ref":"EView.Views.Error.html"},{"type":"function","title":"EView.Views.Error.render/2","doc":"This render will be used by-default for internal errors. You can use it in your controller:\n\n      conn |> render(\"500.json\", %{type: my_type})","ref":"EView.Views.Error.html#render/2"},{"type":"module","title":"EView.Views.PhoenixError","doc":"Error view that can be used in Phoenix:\n\n    config :myapp, MyApp.Endpoint,\n      render_errors: [view: EView.Views.PhoenixError, accepts: ~w(json)]","ref":"EView.Views.PhoenixError.html"},{"type":"function","title":"EView.Views.PhoenixError.render/2","doc":"","ref":"EView.Views.PhoenixError.html#render/2"},{"type":"function","title":"EView.Views.PhoenixError.template_not_found/2","doc":"","ref":"EView.Views.PhoenixError.html#template_not_found/2"},{"type":"module","title":"EView.Views.ValidationError","doc":"This module provides renders that can be used whenever you want to show validation error.\n\n# Example:\n\n    changeset = %SampleSchema{}\n    |> SampleSchema.changeset(params)\n\n    case changeset.valid? do\n      true ->\n        conn\n        |> put_status(200)\n        |> render(\"page.json\", map_keys_to_atom(params))\n      _ ->\n        conn\n        |> put_status(422)\n        |> render(EView.Views.ValidationError, \"422.json\", changeset)\n    end","ref":"EView.Views.ValidationError.html"},{"type":"function","title":"EView.Views.ValidationError.render/2","doc":"Use this render template whenever you want to return validation error. Currently is supports:\n  * `Ecto.Changeset` errors (you can pass Schema that failed validation or changeset by itself);\n  * `ex_json_schema` validation errors.","ref":"EView.Views.ValidationError.html#render/2"},{"type":"function","title":"EView.Views.ValidationError.render/3","doc":"Render a JSON Schema validation error.","ref":"EView.Views.ValidationError.html#render/3"},{"type":"extras","title":"Demo","doc":"# Demo\n\nIn [Nebo #15](http://nebo15.com) we have our own [API design manifest](http://docs.apimanifest.apiary.io/), and we trying to follow it.\n\nThis package extracts all common patterns and utilities, to remove boilerplate from business-logic services.","ref":"readme.html"},{"type":"extras","title":"Installation - Demo","doc":"The package can be installed as:\n\n  1. Add `eview` to your list of dependencies in `mix.exs`:\n\n    ```elixir\n    def deps do\n      [{:eview, \"~> 0.12.1\"}]\n    end\n    ```\n\n  2. Ensure `eview` is started before your application:\n\n    ```elixir\n    def application do\n      [applications: [:eview]]\n    end\n    ```\n\nThe docs can be found at [https://hexdocs.pm/eview](https://hexdocs.pm/eview).","ref":"readme.html#installation"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,51,46,48]}}